gvisor/pkg/sentry/fsimpl/ext/benchmark/make_deep_ext4.sh

73 lines
1.9 KiB
Bash
Raw Normal View History

ext: Benchmark tests. Added benchmark tests which emulate memfs benchmarks. Stat benchmarks BenchmarkVFS2Ext4fsStat/1-12 10000000 145 ns/op BenchmarkVFS2Ext4fsStat/2-12 10000000 170 ns/op BenchmarkVFS2Ext4fsStat/3-12 10000000 202 ns/op BenchmarkVFS2Ext4fsStat/8-12 3000000 374 ns/op BenchmarkVFS2Ext4fsStat/64-12 500000 2159 ns/op BenchmarkVFS2Ext4fsStat/100-12 300000 3459 ns/op BenchmarkVFS1TmpfsStat/1-12 5000000 348 ns/op BenchmarkVFS1TmpfsStat/2-12 3000000 487 ns/op BenchmarkVFS1TmpfsStat/3-12 2000000 655 ns/op BenchmarkVFS1TmpfsStat/8-12 1000000 1365 ns/op BenchmarkVFS1TmpfsStat/64-12 200000 9565 ns/op BenchmarkVFS1TmpfsStat/100-12 100000 15158 ns/op BenchmarkVFS2MemfsStat/1-12 10000000 133 ns/op BenchmarkVFS2MemfsStat/2-12 10000000 155 ns/op BenchmarkVFS2MemfsStat/3-12 10000000 182 ns/op BenchmarkVFS2MemfsStat/8-12 5000000 310 ns/op BenchmarkVFS2MemfsStat/64-12 1000000 1659 ns/op BenchmarkVFS2MemfsStat/100-12 500000 2787 ns/op Mount Stat benchmarks BenchmarkVFS2ExtfsMountStat/1-12 5000000 245 ns/op BenchmarkVFS2ExtfsMountStat/2-12 5000000 266 ns/op BenchmarkVFS2ExtfsMountStat/3-12 5000000 304 ns/op BenchmarkVFS2ExtfsMountStat/8-12 3000000 456 ns/op BenchmarkVFS2ExtfsMountStat/64-12 500000 2308 ns/op BenchmarkVFS2ExtfsMountStat/100-12 300000 3482 ns/op BenchmarkVFS1TmpfsMountStat/1-12 3000000 488 ns/op BenchmarkVFS1TmpfsMountStat/2-12 2000000 658 ns/op BenchmarkVFS1TmpfsMountStat/3-12 2000000 806 ns/op BenchmarkVFS1TmpfsMountStat/8-12 1000000 1514 ns/op BenchmarkVFS1TmpfsMountStat/64-12 100000 10037 ns/op BenchmarkVFS1TmpfsMountStat/100-12 100000 15280 ns/op BenchmarkVFS2MemfsMountStat/1-12 10000000 212 ns/op BenchmarkVFS2MemfsMountStat/2-12 5000000 232 ns/op BenchmarkVFS2MemfsMountStat/3-12 5000000 264 ns/op BenchmarkVFS2MemfsMountStat/8-12 3000000 390 ns/op BenchmarkVFS2MemfsMountStat/64-12 1000000 1813 ns/op BenchmarkVFS2MemfsMountStat/100-12 500000 2812 ns/op PiperOrigin-RevId: 262477158
2019-08-09 01:44:28 +00:00
#!/bin/bash
# Copyright 2019 The gVisor Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# This script creates an ext4 image with $1 depth of directories and a file in
# the inner most directory. The created file is at path /1/2/.../depth/file.txt.
# The ext4 image is written to $2. The image is temporarily mounted at
# /tmp/mountpoint. This script must be run with sudo privileges.
# Usage:
# sudo bash make_deep_ext4.sh {depth} {output path}
# Check positional arguments.
if [ "$#" -ne 2 ]; then
echo "Usage: sudo bash make_deep_ext4.sh {depth} {output path}"
exit 1
fi
# Make sure depth is a non-negative number.
if ! [[ "$1" =~ ^[0-9]+$ ]]; then
echo "Depth must be a non-negative number."
exit 1
fi
# Create a 1 MB filesystem image at the requested output path.
rm -f $2
fallocate -l 1M $2
if [ $? -ne 0 ]; then
echo "fallocate failed"
exit $?
fi
# Convert that blank into an ext4 image.
mkfs.ext4 -j $2
if [ $? -ne 0 ]; then
echo "mkfs.ext4 failed"
exit $?
fi
# Mount the image.
MOUNTPOINT=/tmp/mountpoint
mkdir -p $MOUNTPOINT
mount -o loop $2 $MOUNTPOINT
if [ $? -ne 0 ]; then
echo "mount failed"
exit $?
fi
# Create nested directories and the file.
if [ "$1" -eq 0 ]; then
FILEPATH=$MOUNTPOINT/file.txt
else
FILEPATH=$MOUNTPOINT/$(seq -s '/' 1 $1)/file.txt
fi
mkdir -p $(dirname $FILEPATH) || exit
touch $FILEPATH
# Clean up.
umount $MOUNTPOINT
rm -rf $MOUNTPOINT